// rev 16 avr 2016
//  Nokia LCD
//  pin support LCD Nokia  1 .. 8  sur connecteur Blanc Platine  pins 1 .. 8
#define D_C LATC.B1
#define SCE LATC.B0
#define RES LATC.B2
#define SCK LATC.B3
#define SDI LATC.B4

#ifndef Byte
#define Byte
#endif

#define      COMPRIME     1  // Font 3x6
#define      NORMAL       2  // Font 5x7
#define      LARGE        0  // Font 7x8


extern float F1;
extern *table;
extern *Ram_Video;
extern *txt;
extern char Ligne18cars;

void Nokia_Init_Lcd(void);
void Nokia_SendCmd(char x);
void Nokia_SendData(char x);
void Nokia_Erase_Line(int L);
void Nokia_Clear(void);
void Nokia_Write_Char_At(char Lig,char Col, unsigned char c);
void Bargraph (int V , int ligne);

void Nokia_Chr_8x7(char Lx,char Cx, char charsel);
void Nokia_SendChar(char x);
void Nokia_SendPack(char x);
void Nokia_Text_Lig_Col(int y, int x, char size,Byte *caracter);
void Nokia_CText_5x7(char L,char  C, const char *TxT);
void Nokia_CText_8x7(char L,char  C, const char *txt);

void Nokia_Raz_Ram_Video(void)  ;
void Nokia_Goto_xy(char xnokia, char ynokia)  ;
void Nokia_Pos_Lig_Col( char Lig, char Col,char size);

void Nokia_Put_Pixel (char x, char y, char color) ;
void Nokia_Partial_Image(char xNOKIA, char yNOKIA, char xImage, char array_length, const char *image);
//void Nokia_Partial_Image(3,38,30,60,asd_bmp);
void Nokia_Bitmap(unsigned char x, unsigned char y, unsigned char * bitmap, unsigned char height,unsigned char width);
void Nokia_Print_Ram_Video(void);
void Nokia_Image_96x64(const char *image) ;

void Nokia_Rectangle (char x1, char y1, char x2, char y2, char color); //Public
void Nokia_Bitmap_xy (int x, int y, char *bitmap, int height, int width); // Public

void Nokia_Line (char x1, char y1, char x2, char y2, char color);
void Nokia_Rect (char x1, char y1, char x2, char y2, char color);


void Nokia_Goto_xy(char xnokia, char ynokia)      // Nokia LCD 3310 Position cursor  grafique
{
      Nokia_SendCmd(0x40|(ynokia&0x07));   // Y axe initialisation: 0100 0yyy
      Nokia_SendCmd(0x80|(xnokia&0x7f));   // X axe initialisation: 1xxx xxxx
 }
 
void Nokia_Pos_Lig_Col( char Lig, char Col, char size)
{
  unsigned char C;
  C=Col-1;
  Nokia_SendCmd(0x40|((Lig-1) & 0x07));  //  Y axe initialisation: 0100 0yyy
   switch(size)
  {
    case 1:Nokia_SendCmd(0x80|((C*3)& 0x7f)); break;   // X axe initialisation: 1xxx xxxx
    case 2:Nokia_SendCmd(0x80|((C*5)& 0x7f)); break;
    case 3:Nokia_SendCmd(0x80|((C*7)& 0x7f)); break;
   }

}


void Nokia_Init_Lcd(void)
{
RES =1;
SCE =1;
RES =0;
Delay_ms(200);
RES=1;            // come out of lcd state
Nokia_SendCmd(0x21);    //Function SET: 00100_PD_V_H
Nokia_SendCmd(0x90);    //VLCD=;3.06+162*0.06=4.02
Nokia_SendCmd(0x05);    //; TC0=1 TC1=0
Nokia_SendCmd(0x13);    //bias System 1:48 -> n=4
Nokia_SendCmd(0x20);    //Function SET: 00100_PD_V_H
Delay_ms(10);
Nokia_SendCmd(0x0C);
Nokia_Clear();
Delay_ms(100);
Nokia_SendCmd(0x40);  //  Y=0 0100 0yyy
Nokia_SendCmd(0x80);  //  X =0 1xxx xxxx
}

void Nokia_SendCmd(char x)
{
D_C= 0;
SCE=0;
Nokia_SendPack(x);
Delay_ms(1);
SCE=1; //deselect the display
return;
}

void Nokia_SendData(char x)
{
D_C= 1;
   Delay_us(2);
SCE=0;
   Delay_us(2);
Nokia_SendPack(x);
SCE=1; //deselect the display
}

void Nokia_SendPack(char x)
{ int i;
 for(i=0;i<8;i++)
 {
   SCK=0;
   Delay_us(2);
  //   if((Cc && 0x80)==1)
  if ((x&0x80)==0x80) SDI=1; else SDI=0;
   Delay_us(2);
   SCK=1;
  x=x<<1;
     Delay_us(2);
 }
}

void Nokia_Erase_Line(int L)
{
 int i,j;
 Nokia_Pos_Lig_Col(L,0,2);
 Delay_ms(10);
 i=(L-1)*96;;
 j=i+96;
 for(L=i;L<j;L++)
 {
 Nokia_SendData(0x00);
 Delay_ms(1);
 }
   Nokia_Pos_Lig_Col(L,0,2);
   Delay_ms(2);
}


void Nokia_Erase_Line_(int L)
{
// int i,j;
  Nokia_Goto_xy(L,0);
  Nokia_CText_5x7(L,0,"                ");
  Nokia_Goto_xy(L,0);
}


void Nokia_Clear(void)
{
 int i;
 Nokia_SendCmd(0x40);  //  Y=0 0100 0yyy
 Nokia_SendCmd(0x80);  //  X =0 1xxx xxxx
 Delay_ms(10);
 for(i=0;i<768;i++)
 {
 Nokia_SendData(0x00);
 Delay_ms(1);
 }
}



void Bargraph (int V , int ligne)
{
  unsigned int i,j,m;
   F1= (float)V *96.0/1024.0;
   m=(unsigned int)F1;
  if ((ligne>0) && (ligne<9))    //   1  8
  {
    Nokia_SendCmd(0x40|((ligne-1) & 0x07));
   for (i=0;i<94;i++)
   {
     Nokia_SendCmd(0x80|i);
     if (i<=m)  Nokia_SendData(0x3C); else  Nokia_SendData(0x00);
     Delay_us(5);
   }
    Nokia_SendCmd(0x40|((ligne-1) & 0x07));
  }
 }





void Nokia_Write_Char_At(char Lig,char Col, unsigned char cc)
 { char Cl;
   Cl=Col;
   // attention Lig varie de 1  8   Col 1  18 ! au lieu de 1  16
   Nokia_SendCmd(0x40|((Lig-1) & 0x07));  //  Y axe initialisation: 0100 0yyy
    if (Ligne18Cars==1)
     Nokia_SendCmd(0x80|((Cl*5)& 0x7f));// pour 18 car par ligne
     else
      Nokia_SendCmd(0x80|((Cl*6)& 0x7f));    // 16 cars ?
   Nokia_SendChar(cc);
   }


void Nokia_SendChar(char x)
{ 
 int a,b;
 char c;
  // table de caractere de 32  127
  if((x<0x20)||(x>0x7f)) return;
  // caractere de 5 pixel de large => 32 x 5 = 160
  // offset 160 pour debut car ascii
  a=(5*x)-160;
  for (b=0;b<5;b++)
  //  for(b=5;b>0;b--)    // explore chaque byte du caractere  18 cars per line ???
  {
    c=table[a];
    Nokia_SendData(c);  // envoi les 8 bits
    a++;
  }
  Nokia_SendData(0x00);  // espace inter caractere
}


 void Nokia_CText_5x7(char L1,char C1,const char * txt)
 {
  unsigned char posX,cx ;
  posX=C1-1;
  Nokia_SendCmd(0x40|((L1-1) & 0x07));  //  Y axe initialisation: 0100 0yyy
  Nokia_SendCmd(0x80|((posX*5) & 0x7f));  //  X axe initialisation: 1xxx xxxx
  if (L1>8) return ;
  while(*(txt)>0)
  {
  if (posX>16) break;
  cx=*(txt++);
  Nokia_SendChar(cx);
  posX++;
  }
 }
 


void Nokia_Raz_Ram_Video(void)
{
 int ddram;
 Nokia_SendCmd(0x40);  //  Y=0 0100 0yyy
 Nokia_SendCmd(0x80);  //  X =0 1xxx xxxx
 for (ddram=0;ddram<768;ddram++)   Ram_Video[ddram]=0;
}

void Nokia_Print_Ram_Video(void)
{
  int ddram;
  Nokia_SendCmd(0x40);  //  Y=0 0100 0yyy
  Nokia_SendCmd(0x80);  //  X =0 1xxx xxxx
  for (ddram=0;ddram<768;ddram++) Nokia_SendData(Ram_Video[ddram]);
}


void Nokia_Put_Pixel (char x, char y, char color)
{
   int idx;
   idx = ((int)(y/8) * 96) + x;
   if (color)
       Ram_Video[idx] = Ram_Video[idx] | (1<< (y % 8));
   else
       Ram_Video[idx] = Ram_Video[idx] & (0xFF - (1<< (y % 8)));
}


void Nokia_Image_96x64(const char *image)     // *** OK ! *****
// and display image on terminal  for debuging purpose
{
int i,j,x;
 unsigned int k;
 unsigned char masque;
 unsigned char cx;
 Nokia_SendCmd(0x40);  //  Y=0 0100 0yyy
 Nokia_SendCmd(0x80);  //  X =0 1xxx xxxx
 #ifdef Debug_BMP
 UART1_Write_CText("\r\n Image 96x64\r\n");
  #endif
 for (j=0;j<64;j++)
 {
  for (i=0;i<12;i++)
  {
   k=i+j*12  ;
   cx= image[k];
   masque = 0x80;
   x=0;
   while (masque > 0 )
   {
   k=i*8+x;
     if ((cx & masque)==masque)
      {
      #ifdef Debug_BMP
      UART1_Write('*');  //   '1'
      #endif
      Nokia_Put_Pixel(k,j,1);
      }
     else
     {
     #ifdef Debug_BMP
      UART1_Write(' ');  //  '0'
      #endif
      Nokia_Put_Pixel(k,j,0);
     }
       masque =masque /2;
       x++;
       Delay_us(20);
   }
  }
   #ifdef Debug_BMP
  UART1_Write(13);
  UART1_Write(10);
  #endif
 }
}

void Nokia_Chr_8x7(char Lx,char Cx, char charsel)
{
      char char_row;
      char data1;
      int charposition;
      Nokia_SendCmd(0x40|((Lx-1) & 0x07));  //  Y axe initialisation: 0100 0yyy
      Nokia_SendCmd(0x80|(((Cx-1)*8) & 0x7f));  //  X axe initialisation: 1xxx xxxx
      if (charsel<0x20) return;
      if (charsel>0x7f) return;
        for(char_row=0;char_row<7;char_row++)
        {
               charposition=(((charsel&0x7f)-0x20)*7);
                data1= Font_7_8[charposition+char_row];
                Nokia_SendData(data1);
                
        }
        Delay_us(2);
        Nokia_SendData(0x00);
}


 void Nokia_CText_8x7(char Lt,char  Ct, const char *txt1)
 {
  unsigned char posX,posY;
  posX=Ct;
  posY=Lt;
  if (Lt>8)  return;
  while(*(txt1)>0)
  {
  if (posX>12)break;
  Nokia_Chr_8x7(posY,posX,*(txt1++));
  posX++;
  }
 }


 
// Affichage d'une ligne dans la RAM video
void Nokia_Line (char x1, char y1, char x2, char y2, char color)
{
   char DeltaX, DeltaY,MinX,MinY,MaxX,MaxY,DeltaMax,i,xx,yy;
   float OffsetX, OffsetY;
   if (y1>y2)
      {MinY=y2;MaxY=y1;OffsetY=-1.0;}
   else
      {MinY=y1;MaxY=y2;OffsetY=1.0;}
   if (y1==y2) OffsetY=0;
   if (x1>x2)
      {MinX=x2;MaxX=x1;OffsetX=-1.0;}
   else
      {MinX=x1;MaxX=x2;OffsetX=1.0;}
   if (x1==x2) OffsetX=0;
   DeltaX = MaxX-MinX+1;
   DeltaY = MaxY-MinY+1;
   if (DeltaX>DeltaY)
      {
         OffsetY = (float)DeltaY / (float)DeltaX * OffsetY;
         DeltaMax=DeltaX;
      }
   else
      {
         OffsetX = (float)DeltaX / (float)DeltaY * OffsetX;
         DeltaMax=DeltaY;
      }
   for (i=0;i<DeltaMax;i++)
      {
         xx=x1 + OffsetX * i;
         yy=y1 + OffsetY * i;
         if ((xx<96) && (yy<64) && (xx>=0) && (yy>=0))
            Nokia_Put_Pixel (xx,yy, color);
      }
}


// Affichage d'un rectangle dans la RAM video
void Nokia_Rect (char x1, char y1, char x2, char y2, char color)
{
   int i;
   Nokia_Line (x1,y1,x2,y1,color);
   Nokia_Line (x1,y2,x2,y2,color);
   Nokia_Line (x2,y1,x2,y2,color);
   Nokia_Line (x1,y1,x1,y2,color);

}
/*
  Partie  debuguer

 void Nokia_Partial_Image(char xNOKIA, char yNOKIA, char xImage, char array_length, const char *image)
{
    char j=0,sayac=0;

      Nokia_SendCmd(0x40|(yNOKIA & 0x07));   // Y axe initialisation: 0100 0yyy
      Nokia_SendCmd(0x80|(xNOKIA & 0x7f));   // X axe initialisation: 1xxx xxxx
    
    
    for(sayac=0;sayac<array_length;sayac++)
    {
     if(sayac > xImage     && sayac < (2*xImage))Nokia_Goto_xy((yNOKIA+1),(xNOKIA+(sayac-xImage)));
     if(sayac > (2*xImage) && sayac < (3*xImage))Nokia_Goto_xy((yNOKIA+2),(xNOKIA+(sayac-2*xImage)));
     if(sayac > (3*xImage) && sayac < (4*xImage))Nokia_Goto_xy((yNOKIA+3),(xNOKIA+(sayac-3*xImage)));
     if(sayac > (4*xImage) && sayac < (5*xImage))Nokia_Goto_xy((yNOKIA+4),(xNOKIA+(sayac-4*xImage)));
     if(sayac > (5*xImage) && sayac < (6*xImage))Nokia_Goto_xy((yNOKIA+5),(xNOKIA+(sayac-5*xImage)));
     if(sayac > (6*xImage) && sayac < (7*xImage))Nokia_Goto_xy((yNOKIA+6),(xNOKIA+(sayac-6*xImage)));
    // Nokia_Write_Data(image[sayac]);
     Nokia_SendData(image[sayac]) ;
    }
}


void Nokia_Text_Lig_Col(int y, int x, char size,Byte *caracter)
{
   int ind_bitmap,memory_index,xx,step;
   Byte width,Data_Caracter;
   Byte letter;
   switch(size)
   {
   case 1: width=3;break;
   case 2: width=5;break;
   case 3: width=7;break;
   }
   letter=*caracter;
   step = y%8;
   while (letter!=0)
      {
       for (xx=0;xx<width;xx++)
         if (((xx+x)<96) && ((xx+x)>=0) && (y>=0)&& (y<=56))
            {
              switch(size)
              {
               case 1:
               {
                memory_index = xx + x + (y*3)*96;
                ind_bitmap = (letter-0x20) * width + xx;
                Data_Caracter = Font_3_6[ind_bitmap];
                break;
               }
               case 2:
                {
                 memory_index = xx + x + (y*5)*96;
                ind_bitmap = (letter-0x20) * width + xx;
                Data_Caracter = table[ind_bitmap];
                break;
               }
                 case 3:
               {
                memory_index = xx + x + (y*8)*96;
                ind_bitmap = (letter-0x20) * width + xx;
                Data_Caracter = Font_7_8[ind_bitmap];
                break;
                }
              }
             Ram_Video[memory_index] = Ram_Video[memory_index] | (Data_Caracter<<step);
             if (step)
              Ram_Video[memory_index+96] = Ram_Video[memory_index+96] | ((Data_Caracter>>(8-step)) &
(0xFF >> (8-step)));
            }
            caracter++;
            letter=*caracter;
            x=x+width+1;
      }
}

*/